-- ElvUI Companions Rewrite for 5.0.4 <Companions LDB>
-- by Lockslap <adam at lockslap dot com>

-- Based on BrokerPets by Shackleford
local E, L, V, P, G = unpack(ElvUI); --Inport: Engine, Locales, PrivateDB, ProfileDB, GlobalDB
local DT = E:GetModule("DataTexts")
local Frame = CreateFrame("Frame")
local menu = {}
local startChar = {
	["AB"] = {
	},
	["CD"] = {
	},
	["EF"] = {
	},
	["GH"] = {
	},
	["IJ"] = {
	},
	["KL"] = {
	},
	["MN"] = {
	},
	["OP"] = {
	},
	["QR"] = {
	},
	["ST"] = {
	},
	["UV"] = {
	},
	["WX"] = {
	},
	["YZ"] = {
	}
}
local defaults = {
	["id"]			= nil,
	["text"]		= nil,
	["icon"]		= nil,
	["favOne"]		= nil,
	["favTwo"]		= nil,
	["favThree"]	= nil,
}

local wipe		= table.wipe
local tinsert	= table.insert
local sort		= table.sort
local format	= string.format


local function OnClick(self, button)
	GameTooltip:Hide()

	if (button == 'RightButton' and not IsShiftKeyDown()) then
		ToggleDropDownMenu(1, nil, Frame, self, 0, 0)
		--local numPets, numOwned = C_PetJournal.GetNumPets(false)
		--DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00BrokerPets:|r menu toggled %s", numPets))
	end
	if (IsShiftKeyDown() and button == 'LeftButton') then	
		TogglePetJournal()
		PetJournalParent_SetTab(PetJournalParent, 2)
		--SummonRandomCritter()
	end
	if (button == 'LeftButton' and not IsShiftKeyDown()) then	
		if petdb.id ~= nil then
			C_PetJournal.SummonPetByID(petdb.id);
		end
	end	
	if (IsShiftKeyDown() and button == 'RightButton') then
		if IsAddOnLoaded("Blizzard_PetJournal") then
			ToggleDropDownMenu(1, nil, PetJournalFilterDropDown, self, 0, 0)
		else
			local loaded, reason = LoadAddOn("Blizzard_PetJournal")
			ToggleDropDownMenu(1, nil, PetJournalFilterDropDown, self, 0, 0)
		end
	end
end
local LDB = LibStub("LibDataBroker-1.1"):NewDataObject("CompanionsDT", {
	icon	= "Interface\\Icons\\inv_quilinpet",
	text	= "CompanionsDT",
	type	= "data source",
	OnClick	= OnClick
})

local function pairsByKeys(startChar, f)
	local a = {}
	for n in pairs(startChar) do tinsert(a, n) end
	sort(a, f)
	local i = 0
	local iter = function()
		i = i + 1
		if a[i] == nil then
			return nil
		else
			return a[i], startChar[a[i]]
		end
	end
	return iter
end

local function UpdateDisplay()
	if petdb.id ~= nil then
		LDB.text = petdb.text
		LDB.icon = petdb.icon
	end
	
	local summonedPetID = C_PetJournal.GetSummonedPetID()
	
	if summonedPetID then
		local speciesID, customName, petlevel, xp, maxXp, displayID, petName, petIcon, petType, creatureID = C_PetJournal.GetPetInfoByPetID(summonedPetID)
		local creatureName = petName
		if customName then
			creatureName = customName
		end
		if creatureName then
			LDB.text = ("|cff00ff00%s|r"):format(creatureName)
			LDB.icon = petIcon
			petdb.id = summonedPetID
			petdb.text = creatureName
			petdb.icon = petIcon
			return
		end
	end
end

local function ModifiedClick(button, id)
	local speciesID, customName, petlevel, xp, maxXp, displayID, petName, petIcon, petType, creatureID = C_PetJournal.GetPetInfoByPetID(id)
	local creatureName = petName
	if customName then
		creatureName = customName
	end
	
	if IsShiftKeyDown() then
		C_PetJournal.PickupPet(Id);
	elseif IsAltKeyDown() and not IsControlKeyDown() then
		petdb.favOne = id
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00ElvUI_Companions:|r %s added as favorite 1.", creatureName))
	elseif IsControlKeyDown() and not IsAltKeyDown() then
		petdb.favTwo = id
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00ElvUI_Companions:|r %s added as favorite 2.", creatureName))
	elseif IsControlKeyDown() and IsAltKeyDown() then
		petdb.favThree = id
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00ElvUI_Companions:|r %s added as favorite 3.", creatureName))
	else
		C_PetJournal.SummonPetByID(id);
	end	
end

function LDB.OnEnter(self)
	DT:SetupTooltip(self)
	local numPets, numOwned = C_PetJournal.GetNumPets(false);
	GameTooltip:AddLine("|cff00ffffElvUI_Companions - Companions Datatext|r")
	GameTooltip:AddLine("     <Right Click> to open pet list")
	GameTooltip:AddLine("     <Left Click> to summon/dismiss pet")
	GameTooltip:AddLine("     <Shift-Left Click> plugin to open pet journal")
	GameTooltip:AddLine("     <Shift-Right Click> plugin to open filter menu")
	GameTooltip:AddLine("     <Shift-Left Click> pet to pick it up")
	GameTooltip:AddLine("     <ALT-Click> pet to set as favorite 1")
	GameTooltip:AddLine("     <CTRL-Click> pet to set as favorite 2")
	GameTooltip:AddLine("     <CTRL-ALT-Click> pet to set as favorite 3")
	if numOwned == 0 then
		GameTooltip:AddLine("|cffff0000You have no pets|r")
	else
		GameTooltip:AddLine(format("|cff00ff00You have %s pets|r", numOwned))
	end
	GameTooltip:Show()
end

local function CreateMenu(self, level)
	menu = wipe(menu)
	local numPets, numOwned = C_PetJournal.GetNumPets(false)
	local firstChar
	
	if numPets <= 20 then
		for i = 1, numPets do
			--local speciesID, customName, level, xp, maxXp, displayID, petName, petIcon, petType, creatureID = C_PetJournal.GetPetInfoByPetID(id)
			local petID, speciesID, isOwned, customName, petlevel, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet = C_PetJournal.GetPetInfoByIndex(i)
			local creatureName = name
			if customName then
				creatureName = customName
			end
			local isSummonable = C_PetJournal.PetIsSummonable(petID)
			--firstChar = strupper(strsub(creatureName, 1, 1))
			if isOwned then
				menu.hasArrow = false; -- Start menu creation
				menu.notCheckable = true;
				menu.text = creatureName
				menu.icon = icon
				menu.colorCode = "|cffffffff"
				menu.func = ModifiedClick
				menu.arg1 = petID
			
				if not isSummonable then
					menu.colorCode = "|cff848484"
				end
			
				local summonedPetID = C_PetJournal.GetSummonedPetID();
				if summonedPetID == petID then
					menu.colorCode = "|cff00ff00"
				end
				UIDropDownMenu_AddButton(menu)
			end
		end
	else
		level = level or 1
		
		if level == 1 then
			for key, v in pairsByKeys(startChar) do
				menu.text = key
				menu.notCheckable = 1
				menu.hasArrow = true
				menu.value = {
					["Level1_Key"] = key
				}
				UIDropDownMenu_AddButton(menu, level)
			end
			
			if petdb.favOne ~= nil then
				local speciesID, customName, petlevel, xp, maxXp, displayID, petName, petIcon, petType, creatureID = C_PetJournal.GetPetInfoByPetID(petdb.favOne)
				local creatureName = petName
				if customName then
					creatureName = customName
				end
				local isSummonable = C_PetJournal.PetIsSummonable(petdb.favOne)
				menu.text = format("1. %s", creatureName)
				menu.icon = petIcon
				menu.colorCode = "|cffffffff"
				menu.func = ModifiedClick
				menu.arg1 = petdb.favOne
				menu.hasArrow = nil
				menu.notCheckable = 1
				if not isSummonable then
					menu.colorCode = "|cff848484"
				end
				
				local summonedPetID = C_PetJournal.GetSummonedPetID();
				if summonedPetID == petdb.favOne then
					menu.colorCode = "|cff00ff00"
				end
				UIDropDownMenu_AddButton(menu, level)
			end
			
			if petdb.favTwo ~= nil then
				local speciesID, customName, petlevel, xp, maxXp, displayID, petName, petIcon, petType, creatureID = C_PetJournal.GetPetInfoByPetID(petdb.favTwo)
				local creatureName = petName
				if customName then
					creatureName = customName
				end
				local isSummonable = C_PetJournal.PetIsSummonable(petdb.favTwo)
				menu.text = format("2. %s", creatureName)
				menu.icon = petIcon
				menu.colorCode = "|cffffffff"
				menu.func = ModifiedClick
				menu.arg1 = petdb.favTwo
				menu.hasArrow = nil
				menu.notCheckable = 1
				if not isSummonable then
					menu.colorCode = "|cff848484"
				end
				
				local summonedPetID = C_PetJournal.GetSummonedPetID();
				if summonedPetID == petdb.favTwo then
					menu.colorCode = "|cff00ff00"
				end
				UIDropDownMenu_AddButton(menu, level)
			end
			
			if petdb.favThree ~= nil then
				local speciesID, customName, petlevel, xp, maxXp, displayID, petName, petIcon, petType, creatureID = C_PetJournal.GetPetInfoByPetID(petdb.favThree)
				local creatureName = petName
				if customName then
					creatureName = customName
				end
				local isSummonable = C_PetJournal.PetIsSummonable(petdb.favThree)
				menu.text = format("3. %s", creatureName)
				menu.icon = petIcon
				menu.colorCode = "|cffffffff"
				menu.func = ModifiedClick
				menu.arg1 = petdb.favThree
				menu.hasArrow = nil
				menu.notCheckable = 1
				if not isSummonable then
					menu.colorCode = "|cff848484"
				end
				
				local summonedPetID = C_PetJournal.GetSummonedPetID();
				if summonedPetID == petdb.favThree then
					menu.colorCode = "|cff00ff00"
				end
				UIDropDownMenu_AddButton(menu, level)
			end
		elseif level == 2 then
			local Level1_Key = UIDROPDOWNMENU_MENU_VALUE["Level1_Key"]
			
			for i = 1, numPets do
				local petID, speciesID, isOwned, customName, petlevel, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet = C_PetJournal.GetPetInfoByIndex(i)
				local creatureName = name
				if customName then
					creatureName = customName
				end
				
				local isSummonable = C_PetJournal.PetIsSummonable(petID)
				firstChar = strupper(strsub(creatureName, 1, 1))
				if isOwned then
					menu.hasArrow = false; -- Start menu creation
					menu.notCheckable = true;
					menu.text = creatureName
					menu.icon = icon
					menu.colorCode = "|cffffffff"
					menu.func = ModifiedClick
					menu.arg1 = petID
				
					if not isSummonable then
						menu.colorCode = "|cff848484"
					end
					
					local summonedPetID = C_PetJournal.GetSummonedPetID();
					if summonedPetID == petID then
						menu.colorCode = "|cff00ff00"
					end
					
					
					if firstChar >= "A" and firstChar <= "B" and Level1_Key == "AB" then
						UIDropDownMenu_AddButton(menu, level)
					end
					
					if firstChar >= "C" and firstChar <= "D" and Level1_Key == "CD" then
						UIDropDownMenu_AddButton(menu, level)
					end
					
					if firstChar >= "E" and firstChar <= "F" and Level1_Key == "EF" then
						UIDropDownMenu_AddButton(menu, level)
					end
					
					if firstChar >= "G" and firstChar <= "H" and Level1_Key == "GH" then
						UIDropDownMenu_AddButton(menu, level)
					end
					
					if firstChar >= "I" and firstChar <= "J" and Level1_Key == "IJ" then
						UIDropDownMenu_AddButton(menu, level)
					end
				
					if firstChar >= "K" and firstChar <= "L" and Level1_Key == "KL" then
						UIDropDownMenu_AddButton(menu, level)
					end
					
					if firstChar >= "M" and firstChar <= "N" and Level1_Key == "MN" then
						UIDropDownMenu_AddButton(menu, level)
					end
					
					if firstChar >= "O" and firstChar <= "P" and Level1_Key == "OP" then
						UIDropDownMenu_AddButton(menu, level)
					end
				
					if firstChar >= "Q" and firstChar <= "R" and Level1_Key == "QR" then
						UIDropDownMenu_AddButton(menu, level)
					end
					
					if firstChar >= "S" and firstChar <= "T" and Level1_Key == "ST" then
						UIDropDownMenu_AddButton(menu, level)
					end
					
					if firstChar >= "U" and firstChar <= "V" and Level1_Key == "UV" then
						UIDropDownMenu_AddButton(menu, level)
					end
					
					if firstChar >= "W" and firstChar <= "X" and Level1_Key == "WX" then
						UIDropDownMenu_AddButton(menu, level)
					end
					
					if firstChar >= "Y" and firstChar <= "Z" and Level1_Key == "YZ" then
						UIDropDownMenu_AddButton(menu, level)
					end
				end
			end
		end
	end
end

function Frame:PLAYER_LOGIN()
	petdb = petdb or {}
	for index, value in pairs(defaults) do
		if type(petdb[index]) == "nil" then
			petdb[index] = value
		end
	end
	
	self:RegisterEvent("COMPANION_UPDATE")
	self.COMPANION_UPDATE = UpdateDisplay
	
	self:RegisterEvent("PET_JOURNAL_LIST_UPDATE")
	self.PET_JOURNAL_LIST_UPDATE = UpdateDisplay
	
	self.initialize = CreateMenu
	self.displayMode = "MENU"
	
	UpdateDisplay()
end

Frame:SetScript("OnEvent", function(self, event, ...) self[event](self, ...) end)
Frame:RegisterEvent("PLAYER_LOGIN")